;
; dasm - ring3 32 bit code disassembler - lifewire / ikx -  622 bytes
;
; disassembles all normal >8386 opcodes too, like cmovcc, movszx, movsx, rdtsc
; bt, shld, imul, etc.
;
; ring0 os instructions like lidt are not inside x86.inc but it shouldn't be
; hard to add them. also no cli sti etc
;
; does not disassemble mmx, katmai and fpu instructions. who cares
;
; returns the length of the opcode @ esi in eax. eax = -1 = error
;
; ebp should point to space using the following datastructure
;
;
;  displacement db ?    ;[reg+imm] can be 16 or 32 depending on prefix (67h)
;  current_type db ?    ;type of opcode (flags, uses imm, etc)
;  immudef db ?         ;length of immediate, 1 2 or 4 bytes
;  length db ?          ;temp space
;  rflag db ?           ;returned rflag, useful if you understand
;  delta dd ?           ;just something
;
;
; remember that this disassembler is more then a length disassembler, it has
; full info of the flags of an instruction, if you ask it friendly ;)
;
; it is not bugfree, but only rare things make it error, like gs: selectors.
;
; tested on nero.exe - 2 mb of code including bt cmov - no errors
; tested on calc.exe - no errors
; tested on kernel32.dll - no errors - except known as gs selector.

;
; and for what is useful? for your meta engine, doh. or for eleete EPO.. 
; anyway, noone codes win32asm nowadays so i had better wrote a VBS
; diassembler. damn, another rainy sunday wasted ;(

;----------------------------------------------------------------------------;
;esi->opcode to dasm
;eax=len
dasm:           mov     [ebp.length],0
                and     [ebp.delta],0
                push    esi
                mov     [ebp.displacement],4
                mov     [ebp.immudef],4
dasm_xxx:       mov     [ebp.rflag],0ffh
                lodsd
                cmp     al,67h
                jne     __l
                mov     [ebp.displacement],2
                jmp     dasm_a
            __l:cmp     al,66h
                jne     dasm_w_
                mov     [ebp.immudef],2
         dasm_a:;inc     [ebp.delta]
                jmp     dasm_is_prefix
        dasm_w_:mov     ebx,eax                 ;first point to good table
                mov     esi,offset dasm_not
                cmp     al,0fh
                jne     __q
;                inc     [ebp.length]
                inc     [ebp.delta]
                add     esi,dasm_eot-dasm_not
                shr     ebx,8

__q:            xor     ecx,ecx
                
                ;ecx specifies datalength in table
                ;edx specifies mask
                ;ebx is the opcode

                ;first init our mask and datalength
                
dasm_initmask:  xor     eax,eax
                xor     edx,edx
                lodsb                           ;get terminator / length
                sub     al,0f9h
                mov     ecx,eax
                lodsb                           ;obtain mask
                cmp     al,0fah
                je      dasm_death
                mov     [ebp.current_type],al
                and     al,1111b
                mov     dh,byte ptr [dasm_masklo+eax]
                mov     dl,byte ptr [dasm_maskhi+eax]

                ;now mask the instruction and compare it with opcodes in our
                ;table.

dasm_mainloop:  mov     eax,ebx
                and     al,dl

                cmp     byte ptr [esi],0fah
                je      dasm_initmask
                cmp     byte ptr [esi],0fbh
                je      dasm_initmask

                cmp     al,[esi]
                je      dasm_foundmaybe

dasm_123:       add     esi,ecx
                jmp     dasm_mainloop

dasm_foundmaybe:

                cmp     cl,1
                je      dasm_oobtc              ;only one byte to check

                and     ah,dh
                cmp     ah,[esi+1]
                jne     dasm_123

dasm_oobtc:     mov     al,[ebp.current_type]

                cmp     al,dasm_prefix          ;fs:, rep, etc
                jne     dasmw__
dasm_is_prefix: inc     [ebp.delta]
                pop     esi
                push    esi
                add     esi,[ebp.delta]
                jmp     dasm_xxx

         dasmw__:
                add     [ebp.length],cl
                and     al,1111b
                cmp     al,0                    ;_no flags
                je      dasm_found
                cmp     al,3
                jb      dasm_orm                ;oorrrmmm in ebx
                je      dasm_worm               ;woorrrmmm in ebx

                cmp     al,6
                jne     __q
                and     bh,11000111b            ;handle oommm like oorrrmmm
                jmp     dasm_orm                ;clear rrr for safety


            __q:cmp     al,10                   ;wmmm instruction is a weirdo
                jne     __x

                mov     al,bl
                and     al,111b
                mov     [ebp.rflag],al
                shr     bl,3
                jmp     dasm_wf

            __x:cmp     al,8                    ;handle woommm like woorrrmmm
                jne     __r                     ;clear rrr for safety
                and     bh,11000111b
                jmp     dasm_worm

            __r:ja      dasm_wf                 ;parse only w flag

dasm_found:     ;mov     [ebp.length],cl

dasm_doimm:     ;now check the (optional) imm
                mov     al,[ebp.current_type]
                cmp     al,dasm_imm+11
                je      dasm_lw
                and     al,11110000b
                jz      dasm_finished           ;no imm

                mov     cl,0
                cmp     al,0a0h
                je      dasm_imm8x
                cmp     al,090h
                je      dasm_imm16x
                cmp     al,080h
                je      dasm_imm32x

                mov     cl,[ebp.immudef]
                jmp     dasm_addimm

dasm_imm32x:    inc     cl
                inc     cl
dasm_imm16x:    inc     cl
dasm_imm8x:     inc     cl

dasm_addimm:    add     [ebp.length],cl
                

dasm_finished:  xor     eax,eax
                mov     al,[ebp.length]
                pop     esi
                add     eax,[ebp.delta]
                ret

dasm_death:     xor     eax,eax
                dec     eax
                pop     esi
                ret

dasm_orm:       call    dasm_do_orm
                jmp     dasm_doimm

dasm_worm:      call    dasm_do_orm

dasm_wf:        mov     al,bl                   ;get the len of imm udef.
                and     al,1b                   ;get lowest bit
                jnz     __q
                mov     [ebp.immudef],1
            __q:
                jmp     dasm_doimm

dasm_lw:        mov     cl,[ebp.displacement]
                jmp     dasm_addimm

;----------------------------------------------------------------------------;
dasm_do_orm:    cmp     cl,2
                je      dasm_kut
                inc     [ebp.length]            ;al orm instructions have one
                                                ;byte cutted in the table. so
dasm_kut:       mov     eax,ebx                 ;i add it here
                and     ah,11000000b
                cmp     ah,11000000b
                je      dasm_orm_x              ;11 = register

                ;ok, o is not 11. if o is not 11 and memory flag is esp then
                ;it is an advanced register opcode like [eax+4*ecx+123] etc
                ;the advanced register info is stored in one byte directly
                ;after the opcode. if the aaa flag is ebp then it doesn't use
                ;+regaaa but +imm32 ... what a mess erh? sigh

                push    eax
                mov     eax,ebx
                and     ah,111b
                cmp     ah,100b ;esp?
                jne     __qqq
                
                mov     cl,[ebp.length]
;                sub     cl,byte ptr [ebp.delta] ;remove prefixes
                inc     [ebp.length]
                cmp     bh,40h
                ja      __qqq
                shl     cl,3                    ;cl*8
                mov     eax,ebx
                shr     eax,cl
                and     al,111b
                cmp     al,101b
                je      dasm_grow4

          __qqq:pop     eax
           __qq:cmp     ah,01000000b            ;01 = [reg+i8]
                jne     __a
                inc     [ebp.length]
                jmp     dasm_orm_x

            __a:cmp     ah,10000000b            ;10 = [reg+imm] (16 or 32)
                jne     __q
                mov     al,[ebp.displacement]
                add     [ebp.length],al
                jmp     dasm_orm_x

            __q:mov     eax,ebx                 ;then it is 00
                and     ah,00000111b
                cmp     ah,00000101b            ;is ebp?
                jne     dasm_orm_x              ;no

                push    eax
dasm_grow4:     pop     eax
                add     [ebp.length],4          ;yes, [imm32]
dasm_orm_x:     and     bh,00111000b
                shl     bh,3
                mov     [ebp.rflag],bh
                ret

;----------------------------------------------------------------------------;

include x86.inc

dasm_end:

;----------------------------------------------------------------------------;
