;
;	blueEbola's opcode tracer
;
;  This is just some code i made after studying intel
; machine architecture.  This function, TraceOp, does
; not work on all instructions, infact it will not work
; on any two-byte op i'm afraid (you know, the ops that
; have prefixes like 0F or FF). I was going to implement those
; but I lost interest in adding to this engine before I got it
; done.  It still works well with normal opcodes though, so
; you should get the idea.
;
;  Believe me, you will not be able to understand
; this code if you do not understand the way intel
; cpu works and how to build opcodes. I recommend you
; read Art of Assembly and have a binary calculator handy
; to understand it fully.  My article just gives a small
; summary on it all.
;
;
; Anyway, with just this single proc: TraceOp, you can
; trace deep into any code you'd like and search for a specific
; opcode (IE. CALL LABEL) then replace LABEL to point to
; your virus :). That is a form of EPO and i use it in
; my virus Win9X.Injection.  I recommend if you do this
; however, you keep track of how deep you go into the code
; and count how many stack modifications there are...
; it might get ugly otherwise.. :) n-e wayz, goodluck
;
;
; P.S. This function cannot do FPU instructions!!
; I have no idea what the results would be!!!!
;
;
; Lastly: I am not responsible for any harm that may occur when using
; this utility.  I've warned you that it may not work on extended opcodes!
;
; *This code compiles with MASM32 (check win32asm.cjb.net) simply compile with
; *Assemble & Link option in QEditor and use PEWRSEC over it.  Good luck with whatever
; *you are using it for.
;
;                                                 -blueEbola
;
; Questions? Criticisms? Threats? kornbizkit536@hotmail.com

.586p
.model flat,stdcall
option casemap :none

include \masm32\include\windows.inc

.data
db 00h
.code
start:	; we are going to trace through our own code
	int 03h		; for you to watch this amazing function in a debugger :)

	lea esi,start
	mov ecx,06
doit:	
	call TraceOp
	dec ecx
	jnz doit
	
	ret
	
; This function does something which i think can be called: length disassembling..
; It is not very optimized, it is a very lengthy function but this is because it does
; so much processing.. Intel's opcode format is such a mess :)
; Basically, this can be used to traverse through a basic set of opcodes
; (meaning, non-fpu and i think its safe to say 386/486 instructions)
; The only data references are those to the tables in the beginning of the code
; (below) you can turn these into [ebp+table_ref] if you'd like and you could use this
; in your own virus.	
TraceOp PROC
		pushad
		xor eax,eax		; clear all these regs
		xor ecx,ecx
		cdq
		xor ebx,ebx
		lodsb			; get the first byte of the opcode
		
		; next we gotta check if it is extended or a single opcode
		; single opcode=exit function our work is done
		; extended=get next opcode
		
		cmp al,00Fh		; is it an extended opcode?
		jz lodsb_another
		
                push esi		; save ESI on stack
                lea esi,byte_table	; put in ESI address of our table of 'one byte opcodes'
		mov ecx,op_imm32_table-byte_table ; size of table go in ECX
		call is_in_byte		; check if this byte exists in our table
		pop esi			; restore ESI
		or eax,eax		; check to see if it does
		jnz ex			; it does, we're done
		mov al,bl		; restore AL (is_in_byte keeps backup AL in BL)
		push esi		; save ESI again
		lea esi,op_imm32_table	; (OPCODE) r32,IMM32 type opcodes
		mov ecx,op_imm8_table-op_imm32_table	; length of the table
		call is_in_byte		; check if it exists in our table
		pop esi			; restore ESI
		or eax,eax		; is it existent???
		jnz __op1_imm32		; yeah, we'll trace to next op and return
		mov al,bl		; restore AL once again
		push esi		; save ESI
		lea esi,op_imm8_table	; (OPCODE) r32/r8,IMM8 type op's
		mov ecx,end_tables-op_imm8_table ; length of the table
		call is_in_byte		; check if it exists in our table... again..
		pop esi	; whoo boring
		or eax,eax	; make it stop
		jnz __op1_imm8	; bah..
	
		mov al,bl
		push eax
		and al,80h		; last bit is set if it contains an immediate operand
		pop eax			; ..
		jnz immediate		; contains immediate, we have to do extra stuffs
	
		jmp continue	; ok, it must have a r/m32 byte, so we decode it
		
__op1_imm8:	lodsb		
		jmp ex
__op1_imm32:	lodsd
		jmp ex		

lodsb_another:	lodsb			; load the real opcode
continue:	lodsb
		mov bl,al		; save al in bl
		call decode_modrm_sib
		
		cmp al,0C0h
		jz ex			; its a reg reg operation, we're done
		cmp al,080h		
		jz fourbyte_op		; four byte operation
		cmp al,040h
		jz onebyte_op		; one byte operation

		mov al,bl		; restore al
		call check_sib_byte	; check if a Scalar Index Byte exists here
		or eax,eax		; no?
		jz ex			; k we leave (its a reg,reg function)
		
		lodsb			; loadin the SIB byte
		jmp ex
		
fourbyte_op:	call check_sib_byte	; check if a sib exists
		or eax,eax
		jz __fourbyte
		lodsb			; yes? load it and the extra four bytes
__fourbyte:	lodsd
		jmp ex
onebyte_op:	call check_sib_byte	; sib byte?
		or eax,eax
		jz __onebyte
		lodsb			; load the sib
__onebyte:	lodsb			; load the one byte
		jmp ex
;-Mini Functions-
decode_modrm_sib: ; decodes MOD-REG-RM32 byte into AL,CL,DL respectively
		  ; OR, decodes SIB byte into the following:
		  ;
		  ; AL = Scale
		  ; CL = Index
		  ; DL = Base
		  ;
		  push 00h
		  push eax
		  and al,0C0h
		  mov [esp+04],EAX
		  mov eax,[esp]
		  and al,038h
		  mov cl,al
		  mov eax,[esp]
		  and al,007h
		  mov dl,al
		  pop eax
		  pop eax
		  ret
check_sib_byte:	  ; checks if there is a SIB byte given the Mod/RM byte
		  call decode_modrm_sib
		  cmp dl,04h		; if MOD!=0C0 and RM32=04 then its a sib byte
		  jnz notsib
		  cmp al,00h
		  jnz notsib
		  xor eax,eax
		  inc eax
		  ret
notsib:		  xor eax,eax
		  ret		  
;###############################################
is_in_byte:	  ; checks to see if byte in AL is in byte_table ESI
		  mov bl,al
next_bytet:		  
		  lodsb
		  cmp al,bl
		  jz foundinbyte
		  dec ecx
		  jnz next_bytet
		  
		  xor eax,eax
		  jmp gogog
foundinbyte:
		  xor eax,eax
		  inc eax
gogog:
		  ret	  
;###############################################
; Immediate coding
immediate:
		mov bl,al
		and al,01h	; get how big the imm operand is
		jnz imm32	; its an imm32
		
		lodsb
		call decode_modrm_sib
		
		cmp al,80h
		jz d_four_imm8
		cmp al,40h
		jz d_one_imm8
		
		lodsb
		jmp ex
		
imm32:		mov al,bl
		and al,02h	; check if it will be imm32 added to r/m32 or imm8
		jnz imm8_thatagain

		lodsb
		call decode_modrm_sib
		
		cmp al,40h
		jz d_one_imm32

		cmp al,80h
		jz d_four_imm32

		lodsd
		jmp ex

d_one_imm32:	lodsd
		lodsb
		jmp ex		
d_four_imm32:	lodsd
		lodsd
		jmp ex
d_four_imm8:	lodsb
		lodsd
		jmp ex
d_one_imm8:	lodsb
		lodsb
		jmp ex
imm8_thatagain:	lodsw
		lodsd
		jmp ex

;-Exit-
ex:		mov [esp+4],ESI	; save ESI
		popad			; restore all regs
		ret			; return to func
byte_table:		; all one byters we need to know
	I = 0
	REPEAT 0Fh
	  db 040h+I
	  db 050h+I	  
	  I = I + 1
	ENDM
	I = 0
	REPEAT 08h
	  db 090h+I
	  I = I + 1
	ENDM
	db 0CCh
	lahf
	clc
	stc
	cld
	std
	sahf
	leave
	cli
	sti
	cwd
	cmc
	cdq
	cbw
	
op_imm32_table:		; all five byte opcodes, usually: (opcode) r32,imm32
	I = 0
	REPEAT 0Fh
	  db 0B0h+I
	  I = I + 1
	ENDM
	db 0E8h		; call
	db 0E9h		; jmp
	db 068h		; push
	db 005h		; add
	db 015h		; adc
	db 01Dh		; sbb
	db 02Dh		; sub
	db 025h		; and
	db 00Dh		; or
	db 035h		; xor
	
op_imm8_table:		; typically two byte opcodes
	db 0EBh
	db 06Ah		; push
	db 004h		; add
	db 014h		; adc
	db 01Ch		; sbb
	db 02Ch		; sub
	db 024h		; and
	db 00Ch		; or
	db 034h		; xor
	db 0CDh		; int
	; conditional jumps table
;	db 077h, 073h, 072h, 076h, 0E3h, 074h, 07Fh, 07Dh, 07Ch, 07Eh
;	db 075h, 071h, 07Bh, 079h, 075h, 070h, 07Ah, 078h, 074h
	I = 0
	REPEAT 0Fh
	 db 70h+I
	 I = I + 1
	ENDM
		
end_tables:	
TraceOp ENDP
	
end start